use config::Config;

/*
#[derive(serde::Deserialize)]
pub struct DatabaseSettings {
    pub username: String,
    pub password: String,
    pub host: String,
    pub port: u16,
    pub database: String,
}

*/
#[derive(serde::Deserialize)]
#[serde(default)]
pub struct Settings {
    // pub database: DatabaseSettings,
    pub port: u16,
}

impl Default for Settings {
    fn default() -> Self {
        Settings { port: 3001 }
    }
}

pub(crate) fn get_configuration() -> Result<Settings, config::ConfigError> {
    Config::builder()
        .add_source(config::File::with_name("./ztd.config").required(false))
        .build()?
        .try_deserialize()
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_for_defaults() {
        let maybe_config = get_configuration();
        assert!(!maybe_config.is_err());
        let config = maybe_config.unwrap();
        assert_eq!(config.port, 3001);
    }
}
